/* DuduSDL
 * dudusdl.h
 *
 * Copyright (C) 2000 Nicolas Peninguy and Colin Leroy
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef DUDU_H
#define DUDU_H

// Uncomment this to disable the use of assertions
#define NDEBUG

#include <assert.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <time.h>
#include <ctype.h>
#include <math.h>

#include <sys/times.h>

#include <SDL.h>
#include <SDL_image.h>


#define NB_IMAGES 300
#define NB_TXT 2

typedef struct t_police {
  SDL_Surface *character[39];  // 26 lettres + 10 chiffres + 3 ponctuation.
  int width;
} police;

police polices[NB_TXT];
extern SDL_Surface * images[NB_IMAGES];
extern SDL_Surface * screen;
extern SDL_Event event;

Uint32 videoflags;

int LoadPic(const char *nom, int num);
int LoadTXT(char *fichier, int num, int w, int h);
void PutPicM(unsigned int num, int x, int y);
void PutPic(unsigned int num, int x, int y);
void Quit(const char *message);
void Init_all(int w, int h, int bpp, Uint32 flags);
void DisplayBuffer(int x, int y);
void ClearBuffer(Uint8 color);
void PutTXTC(int num, char *string, int x, int y);
void PutTXT(int num, char *string, int num2, int x, int y);
void rafraichirEcran (void);
void line(SDL_Surface *dest, int x1, int y1, int x2, int y2, int color);
//void Line(int x1, int y1, int x2, int y2, int color);
void setcolor(SDL_Surface *s, Uint8 num, Uint8 r, Uint8 g, Uint8 b);

void cpu_prepare (void);

#define Line(X1,Y1,X2,Y2,COLOR) line(screen, X1, Y1, X2, Y2, COLOR)


//demande et stocke les paramtres
// nombre de joueurs, rapidit...
void demander_parametres(void);

//charge les images et initialise les graphiques
void charger_donnes(void);

void initialiser_tableau(void);

void afficher_viseur (int numeroJoueur);
void bouger_viseur (int numeroJoueur);
int changer_joueur (int numeroJoueur);
void test_temps (int numeroJoueur);
void test_tir_bulle (int numeroJoueur);
void deplacer_bulle (int numeroJoueur);
int bouleRebond_ou_Arrivee (int numeroJoueur);
void classerBoules (int numeroJoueur);
char comparer (int x, int a, int b);
void testerCouleursIdentiques (int numeroJoueur);
void detecterBoulesLibres (int numeroJoueur);
void descendrePlateau (int numeroJoueur);
void descendreBulles (int numeroJoueur);
void recevoirBoulesMalus (int numeroJoueur);
int compterBoules (int numeroJoueur);
void afficher_elements (int numeroJoueur);
void prevenirBoulesMalus (int numeroJoueur);
void quitter (int numeroJoueur);

extern int gauche[4], droite[4], haut[4], tire[4], mess[4], escape;

// from original dudu.h

// VARIABLES GLOBALES
int laisse_moi;
int tour;
int sens, depsens;
float lastangle;
int boulecours,maxAccr;
int bouleNotee[100];
float angleNote[100];
int nobulle;
int Intens_max;
int bouletirer;
int bouledefaut;
float angleCPU;
float best_angleCPU;
int best_angleCPU_found;
int best_CPU_shot;
int CPU_direction;
float CPU_coef_dir;
//temps
int CPU;
time_t temps;
time_t temps2;
time_t temps3;
time_t tempsTotal;
time_t dernierTemps_horl[4];
int temps4[4];
int dernierTemps;
time_t premierTick;
time_t dernierTick[4];
char tempsRestant[4][2];

//divers
int dbouge[4];
int decompte;
int CPUtire;
//variables relatives aux engrenages
int deg[4];

//'pointeurs' des images
int PLATEAU,VERIN;
int PERDU,GAGNE;
int REBOURS;
int MALUS_ROUGE,MALUS_JAUNE;
char EXPLOSION;
char FIN_EXPLOSION;
int ENGR;

//definition des touches des 4 joueurs

int toucheTir[4];
int toucheGauche[4];
int toucheDroite[4];
int toucheHaut[4];
int toucheMessage[4];

//statistiques
int temp,comment_delay;
int maxBoulesEnvoyees;
int meilleurJoueur;
int nombreParties;
int boulesEnvoyees[4];
int boulesRecues[4];
char scoreChaineCar[4][3];
int scoreJoueur[4];
char nombreCoups[4];

float mindist;
char message[12][21];
int bx, by;
extern char comment[12][30];

int tpst[6];
char t[4];


//parametres
int LIBRE;
int son;
int gravite;
int modeViolent;
int vitesseAxeY;
char nombreJoueurs;
int viseurCoordX[4],viseurCoordY[4];
int tableauJeu[4][4];


//boule
char nombreBoules[4][4];
char bouleEtatExistence[4];
char bouleArrivee[4][800];
char bouleExiste[4][800];
char bouleCouleur[4][800];
float bouleCoordX[4][800];
float bouleCoordY[4][800];
float  bouleCoefDir[4][800];
int bouleVitesseChute[4][800];
char bouleGravite[4][800];
int boulePointAccrochage[4][800][6];
int bouleCourante[4];

int nombreJoueursVivants;
int tremblement[4];
int i,p;

int continuer;
int couleurExiste;

char joueurVivant[4];
int nbBoulesMalusRecuees[4];
float angle;
float a[4];
char degreDescente[4];
int messageHasard[4][12];

int maxHauteur;

#endif


